/*               
 | BCM | wPi |   Name  | Mode | V | Physical | V | Mode | Name    | wPi | BCM |
 +-----+-----+---------+------+---+----++----+---+------+---------+-----+-----+
 |     |     |    3.3v |      |   |  1 || 2  |   |      | 5v      |     |     |
 |   2 |   8 |   SDA.1 |   IN | 1 |  3 || 4  |   |      | 5v      |     |     |
 |   3 |   9 |   SCL.1 |   IN | 1 |  5 || 6  |   |      | 0v      |     |     |
 |   4 |   7 | GPIO. 7 |  OUT | 1 |  7 || 8  | 0 | IN   | TxD     | 15  | 14  |
 |     |     |      0v |      |   |  9 || 10 | 1 | IN   | RxD     | 16  | 15  |
 |  17 |   0 | GPIO. 0 |  OUT | 0 | 11 || 12 | 0 | IN   | GPIO. 1 | 1   | 18  |
 |  27 |   2 | GPIO. 2 |  OUT | 1 | 13 || 14 |   |      | 0v      |     |     |
 |  22 |   3 | GPIO. 3 |  OUT | 0 | 15 || 16 | 0 | IN   | GPIO. 4 | 4   | 23  |
 |     |     |    3.3v |      |   | 17 || 18 | 0 | IN   | GPIO. 5 | 5   | 24  |
 |  10 |  12 |    MOSI | ALT0 | 0 | 19 || 20 |   |      | 0v      |     |     |
 |   9 |  13 |    MISO | ALT0 | 0 | 21 || 22 | 1 | IN   | GPIO. 6 | 6   | 25  |
 |  11 |  14 |    SCLK | ALT0 | 0 | 23 || 24 | 1 | OUT  | CE0     | 10  | 8   |
 |     |     |      0v |      |   | 25 || 26 | 1 | OUT  | CE1     | 11  | 7   |
 |   0 |  30 |   SDA.0 |   IN | 1 | 27 || 28 | 1 | IN   | SCL.0   | 31  | 1   |
 |   5 |  21 | GPIO.21 |  OUT | 0 | 29 || 30 |   |      | 0v      |     |     |
 |   6 |  22 | GPIO.22 |  OUT | 0 | 31 || 32 | 1 | IN   | GPIO.26 | 26  | 12  |
 |  13 |  23 | GPIO.23 |  OUT | 0 | 33 || 34 |   |      | 0v      |     |     |
 |  19 |  24 | GPIO.24 |  OUT | 0 | 35 || 36 | 1 | IN   | GPIO.27 | 27  | 16  |
 |  26 |  25 | GPIO.25 |  OUT | 0 | 37 || 38 | 1 | IN   | GPIO.28 | 28  | 20  |
 |     |     |      0v |      |   | 39 || 40 | 1 | IN   | GPIO.29 | 29  | 21  |
 +-----+-----+---------+------+---+----++----+---+------+---------+-----+-----+
 | BCM | wPi |   Name  | Mode | V | Physical | V | Mode | Name    | wPi | BCM |


My own sub-d-adapter
---------------------
             
                           OUT               IN
Signal    SUB-D wPI  Pin       PIN/BCM-Number       PIN/BCM-Number   Sub-D Pin    Signal    
                                 1                  2
                                 3                  4
                                 5                  6 
Enable      1    7    GPIO4      7 (1==OFF)         8 
                                 9                  10
A-Step      2    0    GPIO17    11                  12
A-Dir       3    2    GPIO27    13                  14
Y-Step      4    3    GPIO22    15                  16
                              	17                  18
                              	19                  20
                             	21                  22    GPIO25         10     Z-Home
                              	23                  24
                              	25                  26
                              	27                  28           
Y-Dir       5      GPIO5      	29                  30    
Z-Step      6      GPIO6      	31                  32    GPIO12         11     A-Home
Z-Dir       7      GPIO13     	33                  34    GNDD 
X-Step      8      GPIO19     	35                  36    GPIO16         12     Y-Home
X-Dir       9      GPIO26     	37                  38    GPIO20         13     X-Home
                              	39                  40    GPIO21         15     Probe-IN



*/

//in rasPIsendEthRaw.c 
#define PINzH   RPI_V2_GPIO_P1_22
#define PINaH   RPI_V2_GPIO_P1_32
#define PINyH   RPI_V2_GPIO_P1_36
#define PINxH   RPI_V2_GPIO_P1_38
#define PIN_P   RPI_V2_GPIO_P1_40



//in rasPIreadEthRaw.c 
#define PINena RPI_V2_GPIO_P1_07         // wPI 07   Enable
#define PINaS  RPI_V2_GPIO_P1_11         // wPI 00   A-Achse  Step
#define PINaD  RPI_V2_GPIO_P1_13         // wPI 02   A-Achse  Dir
#define PINyS  RPI_V2_GPIO_P1_15         // Z-Achse  
#define PINyD  RPI_V2_GPIO_P1_29         // Z-Achse
#define PINzS  RPI_V2_GPIO_P1_31         // X-Achse  
#define PINzD  RPI_V2_GPIO_P1_33         // X-Achse
#define PINxS  RPI_V2_GPIO_P1_35         // Y-Achse 
#define PINxD  RPI_V2_GPIO_P1_37         // Y-Achse  

#define PIN00_OUT PINaS
#define PIN01_OUT PINaD
#define PIN02_OUT PINxS
#define PIN03_OUT PINxD
#define PIN04_OUT PINyS
#define PIN05_OUT PINyD
#define PIN06_OUT PINzS
#define PIN07_OUT PINzD

#define PIN08_OUT PINena
#define PIN09_OUT PIN_P
#define PIN10_OUT PIN_P
#define PIN11_OUT PIN_P
#define PIN12_OUT PIN_P
#define PIN13_OUT PIN_P 
#define PIN14_OUT PIN_P
#define PIN15_OUT PIN_P

#define PIN16_OUT PIN_P
#define PIN17_OUT PIN_P
#define PIN18_OUT PIN_P
#define PIN19_OUT PIN_P
#define PIN20_OUT PIN_P
#define PIN21_OUT PIN_P 
#define PIN22_OUT PIN_P
#define PIN23_OUT PIN_P

#define PIN24_OUT PIN_P
#define PIN25_OUT PIN_P
#define PIN26_OUT PIN_P
#define PIN27_OUT PIN_P
#define PIN28_OUT PIN_P
#define PIN29_OUT PIN_P 
#define PIN30_OUT PIN_P
#define PIN31_OUT PIN_P


#define PIN00_IN PINzH 
#define PIN01_IN PINaH 
#define PIN02_IN PINxH 
#define PIN03_IN PINyH 
#define PIN04_IN PIN_P
#define PIN05_IN PIN_P
#define PIN06_IN PIN_P
#define PIN07_IN PIN_P

#define PIN08_IN PIN_P
#define PIN09_IN PIN_P 
#define PIN10_IN PIN_P
#define PIN11_IN PIN_P
#define PIN12_IN PIN_P
#define PIN13_IN PIN_P 
#define PIN14_IN PIN_P
#define PIN15_IN PIN_P

#define PIN16_IN PIN_P
#define PIN17_IN PIN_P
#define PIN18_IN PIN_P
#define PIN19_IN PIN_P
#define PIN20_IN PIN_P
#define PIN21_IN PIN_P 
#define PIN22_IN PIN_P
#define PIN23_IN PIN_P

#define PIN24_IN PIN_P
#define PIN25_IN PIN_P
#define PIN26_IN PIN_P
#define PIN27_IN PIN_P
#define PIN28_IN PIN_P
#define PIN29_IN PIN_P 
#define PIN30_IN PIN_P
#define PIN31_IN PIN_P




uint8_t P_OUT_array[4][8] = {
	{PIN00_OUT,PIN01_OUT,PIN02_OUT,PIN03_OUT,PIN04_OUT,PIN05_OUT,PIN06_OUT,PIN07_OUT},
	{PIN08_OUT,PIN09_OUT,PIN10_OUT,PIN11_OUT,PIN12_OUT,PIN13_OUT,PIN14_OUT,PIN15_OUT},
	{PIN16_OUT,PIN17_OUT,PIN18_OUT,PIN19_OUT,PIN20_OUT,PIN21_OUT,PIN22_OUT,PIN23_OUT},
	{PIN24_OUT,PIN25_OUT,PIN26_OUT,PIN27_OUT,PIN28_OUT,PIN29_OUT,PIN30_OUT,PIN31_OUT}
	};
	
uint8_t P_IN_array[4][8] = {
	{PIN00_IN,PIN01_IN,PIN02_IN,PIN03_IN,PIN04_IN,PIN05_IN,PIN06_IN,PIN07_IN},
	{PIN08_IN,PIN09_IN,PIN10_IN,PIN11_IN,PIN12_IN,PIN13_IN,PIN14_IN,PIN15_IN},
	{PIN16_IN,PIN17_IN,PIN18_IN,PIN19_IN,PIN20_IN,PIN21_IN,PIN22_IN,PIN23_IN},
	{PIN24_IN,PIN25_IN,PIN26_IN,PIN27_IN,PIN28_IN,PIN29_IN,PIN30_IN,PIN31_IN}
	};
	
uint8_t P_OUT_INV_array[4][8] = {
	{0,1,0,1,0,0,0,1},
	{0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0}
	};
	
#define MASKzH 4       // Pin 10
#define MASKaH 8       // Pin 11
#define MASKxH 1       // Pin 13 
#define MASKyH 2       // Pin 12
#define MASK_P 16      // Pin 15


