

void printBits(size_t const size, void const * const ptr)
{
    unsigned char *b = (unsigned char*) ptr;
    unsigned char byte;
    int i, j;
    for (i=size-1;i>=0;i--)
    {
        for (j=7;j>=0;j--)
        {
            byte = (b[i] >> j) & 1;
            printf("%u", byte);
        }
    }
    puts("");
}


void print_stamp(){
        struct tm *newtime;
        time_t long_time;
        time( &long_time );
        newtime = localtime( &long_time );
        printf("%2d:%2d:%2d - ", newtime->tm_hour, newtime->tm_min, newtime->tm_sec);
}

int getch(void) {
    int character;
    struct termios orig_term_attr;
    struct termios new_term_attr;

    /* set the terminal to raw mode */
    tcgetattr(fileno(stdin), &orig_term_attr);
    memcpy(&new_term_attr, &orig_term_attr, sizeof(struct termios));
    new_term_attr.c_lflag &= ~(ECHO|ICANON);
    new_term_attr.c_cc[VTIME] = 0;
    new_term_attr.c_cc[VMIN] = 0;
    tcsetattr(fileno(stdin), TCSANOW, &new_term_attr);

    /* read a character from the stdin stream without blocking */
    /*   returns EOF (-1) if no character is available */
    character = fgetc(stdin);

    /* restore the original terminal attributes */
    tcsetattr(fileno(stdin), TCSANOW, &orig_term_attr);

    return character;
}

void *thread_func(void *data);
int init_thread(){
        struct sched_param param;
        pthread_attr_t attr;
        pthread_t thread;
        int ret;

        /* Lock memory */
        if(mlockall(MCL_CURRENT|MCL_FUTURE) == -1) {
                printf("mlockall failed: %m\n");
               return(-2);
        }

        /* Initialize pthread attributes (default values) */
        ret = pthread_attr_init(&attr);
        if (ret) {
                printf("init pthread attributes failed\n");
                return ret;
        }

        /* Set a specific stack size  */
        ret = pthread_attr_setstacksize(&attr, PTHREAD_STACK_MIN);
        if (ret) {
            printf("pthread setstacksize failed\n");
                return ret;
        }

        /* Set scheduler policy and priority of pthread */
        ret = pthread_attr_setschedpolicy(&attr, SCHED_FIFO);
        if (ret) {
                printf("pthread setschedpolicy failed\n");
                return ret;
        }
        param.sched_priority = 80;
        ret = pthread_attr_setschedparam(&attr, &param);
        if (ret) {
                printf("pthread setschedparam failed\n");
                return ret;
        }
        /* Use scheduling parameters of attr */
        ret = pthread_attr_setinheritsched(&attr, PTHREAD_EXPLICIT_SCHED);
        if (ret) {
                printf("pthread setinheritsched failed\n");
                return ret;
        }

        /* Create a pthread with specified attributes */
        ret = pthread_create(&thread, &attr, thread_func, NULL);
        if (ret<0) {
                perror("pthread_create");
                printf("create pthread failed: %d\n",ret);
        	return ret;
        }
        return 0;
        }

void print_header()          {
	printf("\nEthernet Header\n");
	printf("\t|-incomming source address     : %.2X-%.2X-%.2X-%.2X-%.2X-%.2X\n",
	rec_header->h_source[0],rec_header->h_source[1],rec_header->h_source[2],
	rec_header->h_source[3],rec_header->h_source[4],rec_header->h_source[5]);
	printf("\t|-expected source address      : %.2X-%.2X-%.2X-%.2X-%.2X-%.2X\n",
	smac[0],smac[1],smac[2],smac[3],smac[4],smac[5]);
	printf("\t|-incomming destination address: %.2X-%.2X-%.2X-%.2X-%.2X-%.2X\n",
	rec_header->h_dest[0],rec_header->h_dest[1],rec_header->h_dest[2],
	rec_header->h_dest[3],rec_header->h_dest[4],rec_header->h_dest[5]);
	printf("\t|-expexted  destination address: %.2X-%.2X-%.2X-%.2X-%.2X-%.2X\n", 
	rmac[0], rmac[1], rmac[2], rmac[3], rmac[4], rmac[5] );
	printf("\t|-type:  %.2X %.2x    payload      : %.2X %.2X %.2X %.2X %.2X %.2X\n",
	(unsigned char)recbuf[13],(unsigned char)recbuf[14],(unsigned char)recbuf[15],
	(unsigned char)recbuf[16],(unsigned char)recbuf[17],(unsigned char)recbuf[18],
	(unsigned char)recbuf[19],(unsigned char)recbuf[20]);
}




int init_rec_socket(){
        printf("init_rec_socket %s\n",dev_name);
        r_sockfd=socket( PF_PACKET, SOCK_RAW, htons( ETH_P_ALL ) );
        if (r_sockfd<0) {
                perror("setsockopt1");
                close(r_sockfd);
                return(EXIT_FAILURE);
        }
        strncpy(ifopts.ifr_name, dev_name, IFNAMSIZ-1);
        ioctl(r_sockfd, SIOCGIFFLAGS, &ifopts);
        ifopts.ifr_flags |= IFF_PROMISC;
        ioctl(r_sockfd, SIOCSIFFLAGS, &ifopts);
        
        /* Bind to device */
        if (setsockopt(r_sockfd, SOL_SOCKET, SO_BINDTODEVICE, dev_name, IFNAMSIZ-1) == -1) {
                perror("SO_BINDTODEVICE");
                close(r_sockfd);
                return(EXIT_FAILURE);
        }

        int flags = fcntl(r_sockfd, F_GETFL);
        flags |= O_NONBLOCK;
        fcntl(r_sockfd, F_SETFL, flags);
        memset(&if_ip, 0, sizeof(struct ifreq));

        if ((r_sockfd = socket( PF_PACKET, SOCK_RAW, htons( ETH_P_ALL))) == -1) {
                perror("non blocking listener: socket");
		return(EXIT_FAILURE);
        }

	flags = fcntl(r_sockfd, F_GETFL);
	flags |= O_NONBLOCK;
	fcntl(r_sockfd, F_SETFL, flags);
        return 0;


}

int init_snd_socket(){
   s_sockfd = socket( PF_PACKET, SOCK_RAW, htons( ETH_P_ALL ) );

     /* bind to interface */
    struct ifreq req;
    printf("sending to MAC: %x:%x:%x:%x:%x:%x\n", smac[0], smac[1], smac[2], smac[3], smac[4], smac[5]);
    memset( &req, 0, sizeof( req ) );

    strcpy( (char*)req.ifr_name, dev_name );

    if ( ioctl( s_sockfd, SIOCGIFINDEX, &req ) < 0 )
    {
        perror( "init: ioctl" );
        close( s_sockfd );
        return -1;
    }

    struct sockaddr_ll addr;
    memset( &addr, 0, sizeof( addr ) );
    addr.sll_family   = PF_PACKET;
    addr.sll_protocol = 0;
    addr.sll_ifindex  = req.ifr_ifindex;

    if ( bind( s_sockfd, (const struct sockaddr*)&addr, sizeof( addr ) ) < 0 )
    {
        perror( "init: bind fails" );
        close( s_sockfd );
        return -1 ;
    }

    if ( ioctl( s_sockfd, SIOCGIFHWADDR, &req ) < 0 )
    {
        perror( "init: ioctl SIOCGIFHWADDR" );
        close( s_sockfd );
        return -1;
    }

	printf("s_sockfd is:%2x\n",s_sockfd);
	return 0;
}

void print_buf(char buf[]){
               int f=0; for (f=0; f<6; f++)printf(":%.2x",(unsigned char)buf[f])&0xff;
               printf("  -->  ");
               for (f=6; f<12; f++)printf(":%.2x",(unsigned char)buf[f])&0xff; printf("\n");
               for (f=17; f<25; f++)printf("[%02d]:%.2x ",f,(unsigned char)buf[f])&0xff; printf("\n");
}
