#include <time.h>


#include <unistd.h>

#include <sys/socket.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <arpa/inet.h>
#include <fcntl.h>

#include <stdio.h>
#include <termios.h>



#define SNDKEY  0x53 //"S"
#define READKEY 0x52 // "R"

void print_stamp();
#include <bcm2835.h>
#include "GPIO.h"



void *thread_func(void *data);
#include <pthread.h>
#include <limits.h>
#include <sys/mman.h>
#define  MY_STACK_SIZE 100


#define ISRASPI 1
#include "defs.h"
#include "commandline.c"
#include "func.c"
int sent;


int gpio_init(){
    if (!bcm2835_init())return 1;
	int f; int byte;
    // Sets the pin as input.
    bcm2835_gpio_fsel(PINzH  , BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(PINaH  , BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(PINyH  , BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(PINxH  , BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(PIN_P  , BCM2835_GPIO_FSEL_INPT);
    // Sets the Pull-up mode for the pin.
    bcm2835_gpio_set_pud(PINzH  , BCM2835_GPIO_PUD_UP);
    bcm2835_gpio_set_pud(PINaH  , BCM2835_GPIO_PUD_UP);
    bcm2835_gpio_set_pud(PINyH  , BCM2835_GPIO_PUD_UP);
    bcm2835_gpio_set_pud(PINxH  , BCM2835_GPIO_PUD_UP);
    bcm2835_gpio_set_pud(PIN_P  , BCM2835_GPIO_PUD_UP);

        for (byte=0; byte<4; byte++){
             for (f=0; f<=7; f++){ bcm2835_gpio_fsel(P_OUT_array[byte][f], BCM2835_GPIO_FSEL_OUTP); }
         }


 }

void gpio_getpin(int key,int bit){
if  (bcm2835_gpio_lev(key)) {port_data_array->inval[0]= port_data_array->inval[0] | bit;} else {port_data_array->inval[0]= port_data_array->inval[0] & (255-bit);};
}



void gpio_get_pins(){
	gpio_getpin(PINzH  ,MASKzH);
	gpio_getpin(PINaH  ,MASKaH);
	gpio_getpin(PINyH  ,MASKyH);
	gpio_getpin(PINxH  ,MASKxH);
	gpio_getpin(PIN_P  ,MASK_P);

}

void setGPIObit(int invert,int buf,int PIN,int bit){
        if (invert>0) buf= ~buf;
        if ((buf&bit)>0) {
                bcm2835_gpio_write(PIN, HIGH);
                if (DEBUG & DEB_MOTOR) printf("PIN_%2d HIGH  ",PIN);
                } else {
                bcm2835_gpio_write(PIN, LOW);
                if (DEBUG & DEB_MOTOR) printf("PIN_%2d LOW   ",PIN);
                }
}

static int tmpcount=0;

int  send_data(){
	gpio_get_pins();
	int pktSz=0;
	int do_send=(port_data_array->inval[0]!=lastGPIOin);
	if  ((testmode & testmode_sflood)>0) do_send=true; 

	if (do_send){
	         memcpy(&sndbuf[0], &smac[0], 6);
	         memcpy(&sndbuf[6], &rmac[0], 6);

                sndbuf[15]='i';   // 0x069  key  
                sndbuf[16]=0;     // second byte
                sndbuf[17]=port_data_array->inval[0];
                sndbuf[18]=port_data_array->inval[1];
                sndbuf[19]=port_data_array->inval[2];
                sndbuf[20]=port_data_array->inval[3];
                sndbuf[21]=port_data_array->inval[4];
                sndbuf[22]=0;     // second byt
                sndbuf[23]=sndcount;
                sndbuf[24]=sndcount;





		pktSz=20;
    		sndbuf[pktSz+6]=SNDKEY;
    		sndbuf[pktSz+7]=sent;
		if (debug>0){
	    		int f=0; for (f=0; f<pktSz; f++)printf("%2x ",sndbuf[f]); printf("\n");
			printf("send to socket:%2x",s_sockfd);
	        	print_buf(sndbuf);
		}
		int bytes = write(s_sockfd, sndbuf, pktSz+20);
		if (bytes<0) { perror("write"); }
		if ((debug&deb_send)>0)	printf("bytes sent:%2x\n",bytes);
		lastGPIOin=port_data_array->inval[0];
		sent=sent+1;
		sndcount=sndcount+1;
                tmpcount++;
                if (tmpcount>100000){print_stamp();printf(" 100k packets sent\n");tmpcount=0;}
	}
// END this part sends the input-bytes of the rasPI as raw packets to MAC-adre
}




static unsigned char lastEthInNr=0, pktInNr=0;
static bool firstEthIn=false;



int rec_data(){
static int count=1;
int f;int byte=0;
        bool isForMe=false;  // is it a packet for me?
	unsigned char val;
        numbytes = read(r_sockfd, recbuf, BUF_SIZ);
        if (numbytes<=0) return 0;
        if ((debug & deb_listen   )>0) printf("listener: got packet %lu bytes\n", numbytes);
     if (memcmp(&rec_header->h_source[0],&smac[0],6)==0) 
	if ( memcmp(&rec_header->h_dest[0],&rmac[0],6)==0) 
		{ isForMe=true; }
 	if (!isForMe) {return;}
	if (debug && DEB_PRINT_MATCHING){print_header();print_buf(recbuf);}
	if (DEBUG & DEB_PAYLOAD){ print_buf(recbuf); }
	if (debug & deb_port){
		printf("lastout[0]:%02d, recbuf[17]:%02d\n", (lastout[0],recbuf[17]));
		printf("lastout[1]:%02d, recbuf[18]:%02d\n", (lastout[1],recbuf[18]));
	}
	for (byte=0; byte<4; byte++){
		if (DEBUG & DEB_MOTOR)print_buf(recbuf);
			for (f=0; f<=7; f++){
				val=(recbuf[byte+17]&(1<<f));
				if (P_OUT_INV_array[byte][f])val=!(recbuf[byte+17]&(1<<f));
					if (debug & deb_port) 
					printf("set P_OUT_array[%02d][%02d] %02d to %02d  INV? %1d  %2d\n",
					byte,f,P_OUT_array[byte][f] , 
					(recbuf[byte+17]&(1<<f)),(P_OUT_INV_array[byte][f]),val); 
					bcm2835_gpio_write(P_OUT_array[byte][f], val);	
				}
			lastout[byte]=recbuf[byte+17];
	}
	count=count+1;
	pktInNr=recbuf[24];
	if (firstEthIn) {firstEthIn=false;lastEthInNr=pktInNr-1;}
	if (lastEthInNr!=((pktInNr-1)&255)){
		printf("PACKET LOST!!!lastEthInNr:%4x pktInNr:%4x\n",lastEthInNr,pktInNr);
	}
	lastEthInNr=pktInNr;
	if (count>100000){ print_stamp();	printf(" 100k packtes received.\n"); count=0; }
}
// END this part receives the output-bytes of the PC as raw packets for MAC-adress 






void *thread_func(void *data){
	lastGPIOin=-1;
	printf("thread is running...\n");




while (1==1) {
	if ((testmode & 1)==0)     send_data();
	if ((testmode & 2)==0)    rec_data();
	if (testmode & 4){
			if (testmode & 8 ) printf("testmode 8\n");
			 bcm2835_gpio_write(PINaS, HIGH);
			 bcm2835_gpio_write(PINaS, LOW);
		} 
	}
	close(r_sockfd);
	close(s_sockfd);
        return NULL;
}




int main(int argc, char *argv[])
{


        printf("rasPIioEthRaw (c) R.Burger 2019  Rev. 0.42  18.02.2019\n");
	printf(" - read/write GPIO-Ports\n");
        printf("as raw-eth-packets\n");

        getCLopt(argc, argv);

	printf("destination MAC: MAC_STR\n",
        smac[0], smac[1], smac[2], smac[3], smac[4], smac[5]);
	 memcpy(&s_dstMac[0], &smac[0], 6);

	printf("rec. for MAC: MAC_STR\n",
        rmac[0], rmac[1], rmac[2], rmac[3], rmac[4], rmac[5]);
	 memcpy(&r_srcMac[0], &rmac[0], 6);
	printf("dev:%s\n",dev_name);

	gpio_init();
	init_rec_socket();
	init_snd_socket();
	init_thread();

// kbd-getch() just for testing/debugging
// ein tastendruck simuliert ein eigehendes datenpaket und setzt
// port_data_array->inval[0] entsprechend - die veraenderungen von port_data_array->inval[0] 
// werden im eigentlichen arbeitsthread verarbeitet
static char c='0';
unsigned int toggle=1;
int f; int mode=0;int byte=0;
usleep(1000000);
while (c!='x'){
	if (c == 'i') mode=0;
	if (c == 'o') mode=1;
	if (c == '+') {byte++; if (byte==4) byte=0; printf("IO-byte:%01d\n",byte);}
        for (f=1; f<=8; f++){
	   if(c == 48+f){  
		printf("(1<<f):=%2d\n",(1<<(f-1)));
		if (mode==0){
			printf(" toggle IN bit %01d of byte[%01d]\n",f,byte); 
			printf("%2x:",port_data_array->inval[byte]); 
			port_data_array->inval[byte] ^= (1<<(f-1)); 
			printf("->%2x\n",port_data_array->inval[byte]); 
			}
		if (mode==1){

			printf(" toggle OUT bit %01d of byte[%01d]  -  PIN: %2d\n",
				f,byte,P_OUT_array[byte][f-1]); 
			printf("%2x:",port_data_array->outval[byte]); 
			port_data_array->outval[byte]=port_data_array->outval[byte] ^= (1<<(f-1)); 
			printf("->%2x\n",port_data_array->outval[byte]);
			bcm2835_gpio_write(P_OUT_array[byte][f-1], port_data_array->outval[byte]);
			}				
		}
	     }
//while (1==1){  //just a test-loop for rasPI
//				for (f=1; f<=8; f++){mode=0;}
//                                        bcm2835_gpio_write(P_OUT_array[0][2], 0);
//				for (f=1; f<=8; f++){mode=0;}
//                                        bcm2835_gpio_write(P_OUT_array[0][2], 1);
//}
///	usleep(10000);
	c = getch();
        }
printf("c=%2x Exit....\n",c);
}
